const calendar = document.querySelector(".calendar"),
    date = document.querySelector(".date"),
    daysContainer = document.querySelector(".days"),
    prev = document.querySelector(".prev"),
    next = document.querySelector(".next"),
    todayBtn = document.querySelector(".today-btn"),
    gotoBtn = document.querySelector(".goto-btn"),
    dateInput = document.querySelector(".date-input"),
    eventDay = document.querySelector(".event-day"),
    eventDate = document.querySelector(".event-date"),
    eventsContainer = document.querySelector(".events"),
    addEventBtn = document.querySelector(".add-event"),
    addEventWrapper = document.querySelector(".add-event-wrapper "),
    addEventCloseBtn = document.querySelector(".close "),
    addEventTitle = document.querySelector(".event-name "),
    addEventFrom = document.querySelector(".event-time-from "),
    addEventTo = document.querySelector(".event-time-to "),
    addEventSubmit = document.querySelector(".add-event-btn ");
    userMeetingTime = document.querySelector(".user_meeting_time ");
 
let myToday = new Date();
let activeDay;
let month = myToday.getMonth();
let year = myToday.getFullYear();

const months = [
    "January",
    "February",
    "March",
    "April",
    "May",
    "June",
    "July",
    "August",
    "September",
    "October",
    "November",
    "December",
];

// const eventsArr = [
//   {
//     day: 13,
//     month: 11,
//     year: 2022,
//     events: [
//       {
//         title: "Event 1 lorem ipsun dolar sit genfa tersd dsad ",
//         time: "10:00 AM",
//       },
//       {
//         title: "Event 2",
//         time: "11:00 AM",
//       },
//     ],
//   },
// ];

const eventsArr = [];
getEvents();


//function to add days in days with class day and prev-date next-date on previous month and next month days and active on today
function initCalendar() {
    const firstDay = new Date(year, month, 1);
    const lastDay = new Date(year, month + 1, 0);
    const prevLastDay = new Date(year, month, 0);
    const prevDays = prevLastDay.getDate();
    const lastDate = lastDay.getDate();
    const day = firstDay.getDay();
    const nextDays = 7 - lastDay.getDay() - 1;

    date.innerHTML = months[month] + " " + year;

    let days = "";

    for (let x = day; x > 0; x--) {
        days += `<div class="day prev-date">${prevDays - x + 1}</div>`;
    }

    for (let i = 1; i <= lastDate; i++) {
        //check if event is present on that day
        let event = false;
        eventsArr.forEach((eventObj) => {
            if (
                eventObj.day === i &&
                eventObj.month === month + 1 &&
                eventObj.year === year
            ) {
                event = true;
            }
        });
        if (
            i === new Date().getDate() &&
            year === new Date().getFullYear() &&
            month === new Date().getMonth()
        ) {
            activeDay = i;
            
            let data123 = document.getElementById("dayData").value
          const arrayData = JSON.parse(data123);
          
            getActiveDay(i,arrayData);
            updateEvents(i);
            if (event) {
                days += `<div class="day today active event">${i}</div>`;
            } else {
                days += `<div class="day today active">${i}</div>`;
            }
        } else {
            if (event) {
                days += `<div class="day event">${i}</div>`;
            } else {
                days += `<div class="day ">${i}</div>`;
            }
        }
    }

    for (let j = 1; j <= nextDays; j++) {
        days += `<div class="day next-date">${j}</div>`;
    }
    daysContainer.innerHTML = days;
    addListner();
}

//function to add month and year on prev and next button
function prevMonth() {
    month--;
    if (month < 0) {
        month = 11;
        year--;
    }
    initCalendar();
}

function nextMonth() {
    month++;
    if (month > 11) {
        month = 0;
        year++;
    }
    initCalendar();
}

prev.addEventListener("click", prevMonth);
next.addEventListener("click", nextMonth);

initCalendar();

//function to add active on day
function addListner() {
    const days = document.querySelectorAll(".day");
    days.forEach((day) => {
        day.addEventListener("click", (e) => {
          var data = $('#dayData').val();
          const arrayData = JSON.parse(data);
               
            getActiveDay(e.target.innerHTML,arrayData);
            updateEvents(Number(e.target.innerHTML));
            activeDay = Number(e.target.innerHTML);
            //remove active
            days.forEach((day) => {
                day.classList.remove("active");
            });
            //if clicked prev-date or next-date switch to that month
            if (e.target.classList.contains("prev-date")) {
                prevMonth();
                //add active to clicked day afte month is change
                setTimeout(() => {
                    //add active where no prev-date or next-date
                    const days = document.querySelectorAll(".day");
                    days.forEach((day) => {
                        if (
                            !day.classList.contains("prev-date") &&
                            day.innerHTML === e.target.innerHTML
                        ) {
                            day.classList.add("active");
                        }
                    });
                }, 100);
            } else if (e.target.classList.contains("next-date")) {
                nextMonth();
                //add active to clicked day afte month is changed
                setTimeout(() => {
                    const days = document.querySelectorAll(".day");
                    days.forEach((day) => {
                        if (
                            !day.classList.contains("next-date") &&
                            day.innerHTML === e.target.innerHTML
                        ) {
                            day.classList.add("active");
                        }
                    });
                }, 100);
            } else {
                e.target.classList.add("active");
            }
        });
    });
}
const element = document.getElementById('myElement');
if (todayBtn) {
    todayBtn.addEventListener("click", () => {
        let mytoday = new Date();
        month = mytoday.getMonth();
        year = mytoday.getFullYear();
        initCalendar();
});
}
if (dateInput) {
    dateInput.addEventListener("input", (e) => {
        dateInput.value = dateInput.value.replace(/[^0-9/]/g, "");
        if (dateInput.value.length === 2) {
            dateInput.value += "/";
        }
        if (dateInput.value.length > 7) {
            dateInput.value = dateInput.value.slice(0, 7);
        }
        if (e.inputType === "deleteContentBackward") {
            if (dateInput.value.length === 3) {
                dateInput.value = dateInput.value.slice(0, 2);
            }
        }
    });
}

if (gotoBtn) {
    gotoBtn.addEventListener("click", gotoDate);
    
    function gotoDate() {
        
        const dateArr = dateInput.value.split("/");
        if (dateArr.length === 2) {
            if (dateArr[0] > 0 && dateArr[0] < 13 && dateArr[1].length === 4) {
                month = dateArr[0] - 1;
                year = dateArr[1];
                initCalendar();
                return;
            }
        }
        alert("Invalid Date");
    }
}
//function get active day day name and date and update eventday eventdate






function getActiveDay(date, openingHours) {
  const day = new Date(year, month, date);
  const dayName = day.toString().split(" ")[0];
  eventDay.innerHTML = dayName;
  eventDate.innerHTML = date + " " + months[month] + " " + year;
  let res = getTimeSlots(dayName, openingHours);
 
 if(res){
     const lastIndex = res.length - 1;
     
  let id = 0;
  let timeHtml = "";
  res.forEach(time => {
  id++;
  let timeSplit = time.split(":");
  let hour = parseInt(timeSplit[0]);
  let minutes = timeSplit[1];

  let suffix = (hour >= 12) ? "PM" : "AM";

  if (hour === 0) {
    hour = 12;
  } else if (hour > 12) {
    hour = hour - 12;
  }

  const timeFormatted = `${hour}:${minutes}`;
  
  timeHtml += `<div class="product_hour_wrapper">
    <div class="product_hour_button" onclick="removeBtns(this)" id="remove_button1${id}" data-id="${id}">
      <span>${(id===1)?timeFormatted+" "+suffix:timeFormatted}</span>
    </div>
    <div class="dual_product_hour" id="replacement_button${id}">
      <div class="d-flex">
        <div class="product_hour_sub_button me-1 " style="width: 50%; background:#777; border:none">
          <span style="color: #fff;">${(id===1)?timeFormatted+" "+suffix:timeFormatted}</span>
        </div>
        <div class="product_hour_sub_button " style="width: 50%; background:#1087ff;" onclick="checkout_form()">
          <span style="color: #fff;">Submit</span>
        </div>
      </div>
    </div>
  </div> `;
});

userMeetingTime.innerHTML = timeHtml;

}else{
    
    //   userMeetingTime.innerHTML = '';
  }
  
  
}

function getTimeSlots(day, openingHours) {
  const validTime = getValidTime(day, openingHours);
  
  if (!validTime) {
    return null;
  }
  let { fromTime, toTime } = validTime;
  
  // Convert fromTime and toTime to 24-hour format
  if (fromTime.indexOf("PM") !== -1 && fromTime.indexOf("12:") === -1) {
    fromTime = convertTo24Hour(fromTime);
  }
  if (toTime.indexOf("PM") !== -1 && toTime.indexOf("12:") === -1) {
    toTime = convertTo24Hour(toTime);
  }

  const timeSlots = [];
  const fromHour = Number(fromTime.split(":")[0]);
  const toHour = Number(toTime.split(":")[0]);

  for (let hour = fromHour; hour <= toHour; hour++) {
    const amPm = hour >= 12 ? "PM" : "AM";
    let slot = `${hour % 12}:00 ${amPm}`;
    if (hour === fromHour) {
      slot = fromTime;
    }
    if (hour === toHour) {
      slot = toTime;
    }
    timeSlots.push(slot);
    if (slot === toTime) {
      break;
    }
    slot = `${hour % 12}:30 ${amPm}`;
    timeSlots.push(slot);
    if (slot === toTime) {
      break;
    }
  }
  return timeSlots;
}





function getValidTime(dayToGet, openingHours) {
  const targetDay = openingHours.find(({ day }) => day.includes(dayToGet));

  if (targetDay) {
    if (targetDay.enable) {
      let fromTime = targetDay.fromTime;
      let toTime = targetDay.toTime;

      // Convert fromTime and toTime to 24-hour format
      if (fromTime.indexOf('PM') !== -1 && fromTime.indexOf('12:') === -1) {
        fromTime = convertTo24Hour(fromTime);
      }
      if (toTime.indexOf('PM') !== -1 && toTime.indexOf('12:') === -1) {
        toTime = convertTo24Hour(toTime);
      }

      return { fromTime, toTime };
    }
  }
}

function convertTo24Hour(time) {
  
  const splitTime = time.split(':');
  splitTime[0] = String(Number(splitTime[0]) + 12);
  return splitTime.join(':').replace(' PM', '');
}




 





//function update events when a day is active
function updateEvents(date) {
    let events = "";
    eventsArr.forEach((event) => {
        if (
            date === event.day &&
            month + 1 === event.month &&
            year === event.year
        ) {
            event.events.forEach((event) => {
                events += `<div class="event">
            <div class="title">
              <i class="fas fa-circle"></i>
              <h3 class="event-title">${event.title}</h3>
            </div>
            <div class="event-time">
              <span class="event-time">${event.time}</span>
            </div>
        </div>`;
            });
        }
    });
    if (events === "") {
        events = `<div class="no-event">
            <h3>No Events</h3>
        </div>`;
    }
    eventsContainer.innerHTML = events;
    saveEvents();
}

//function to add event
if (addEventBtn) {
    addEventBtn.addEventListener("click", () => {
        addEventWrapper.classList.toggle("active");
    });
    
    addEventCloseBtn.addEventListener("click", () => {
        addEventWrapper.classList.remove("active");
    });
    
    document.addEventListener("click", (e) => {
        if (e.target !== addEventBtn && !addEventWrapper.contains(e.target)) {
            addEventWrapper.classList.remove("active");
        }
    });
}

//allow 50 chars in eventtitle
if (addEventTitle) {
 addEventTitle.addEventListener("input", (e) => {
    addEventTitle.value = addEventTitle.value.slice(0, 60);
});
}

// function defineProperty() {
//     var osccred = document.createElement("div");
//   //  osccred.innerHTML =
//         //"A Project By <a href='https://www.youtube.com/channel/UCiUtBDVaSmMGKxg1HYeK-BQ' target=_blank>Open Source Coding</a>";
//     osccred.style.position = "absolute";
//     osccred.style.bottom = "0";
//     osccred.style.right = "0";
//     osccred.style.fontSize = "10px";
//     osccred.style.color = "#ccc";
//     osccred.style.fontFamily = "sans-serif";
//     osccred.style.padding = "5px";
//     osccred.style.background = "#fff";
//     osccred.style.borderTopLeftRadius = "5px";
//     osccred.style.borderBottomRightRadius = "5px";
//     osccred.style.boxShadow = "0 0 5px #ccc";
//     document.body.appendChild(osccred);
// }

//defineProperty();

//allow only time in eventtime from and to
if (addEventTitle) {
    addEventFrom.addEventListener("input", (e) => {
        addEventFrom.value = addEventFrom.value.replace(/[^0-9:]/g, "");
        if (addEventFrom.value.length === 2) {
            addEventFrom.value += ":";
        }
        if (addEventFrom.value.length > 5) {
            addEventFrom.value = addEventFrom.value.slice(0, 5);
        }
    });
}
if (addEventTo) {
addEventTo.addEventListener("input", (e) => {
    addEventTo.value = addEventTo.value.replace(/[^0-9:]/g, "");
    if (addEventTo.value.length === 2) {
        addEventTo.value += ":";
    }
    if (addEventTo.value.length > 5) {
        addEventTo.value = addEventTo.value.slice(0, 5);
    }
});
}

//function to add event to eventsArr
if (addEventSubmit) {
addEventSubmit.addEventListener("click", () => {
    const eventTitle = addEventTitle.value;
    const eventTimeFrom = addEventFrom.value;
    const eventTimeTo = addEventTo.value;
    if (eventTitle === "" || eventTimeFrom === "" || eventTimeTo === "") {
        alert("Please fill all the fields");
        return;
    }

    //check correct time format 24 hour
    const timeFromArr = eventTimeFrom.split(":");
    const timeToArr = eventTimeTo.split(":");
    if (
        timeFromArr.length !== 2 ||
        timeToArr.length !== 2 ||
        timeFromArr[0] > 23 ||
        timeFromArr[1] > 59 ||
        timeToArr[0] > 23 ||
        timeToArr[1] > 59
    ) {
        alert("Invalid Time Format");
        return;
    }

    const timeFrom = convertTime(eventTimeFrom);
    const timeTo = convertTime(eventTimeTo);

    //check if event is already added
    let eventExist = false;
    eventsArr.forEach((event) => {
        if (
            event.day === activeDay &&
            event.month === month + 1 &&
            event.year === year
        ) {
            event.events.forEach((event) => {
                if (event.title === eventTitle) {
                    eventExist = true;
                }
            });
        }
    });
    if (eventExist) {
        alert("Event already added");
        return;
    }
    const newEvent = {
        title: eventTitle,
        time: timeFrom + " - " + timeTo,
    };
   
    
    let eventAdded = false;
    if (eventsArr.length > 0) {
        eventsArr.forEach((item) => {
            if (
                item.day === activeDay &&
                item.month === month + 1 &&
                item.year === year
            ) {
                item.events.push(newEvent);
                eventAdded = true;
            }
        });
    }

    if (!eventAdded) {
        eventsArr.push({
            day: activeDay,
            month: month + 1,
            year: year,
            events: [newEvent],
        });
    }

    
    addEventWrapper.classList.remove("active");
    addEventTitle.value = "";
    addEventFrom.value = "";
    addEventTo.value = "";
    updateEvents(activeDay);
    //select active day and add event class if not added
    const activeDayEl = document.querySelector(".day.active");
    if (!activeDayEl.classList.contains("event")) {
        activeDayEl.classList.add("event");
    }
});
}

//function to delete event when clicked on event
if (eventsContainer) {
eventsContainer.addEventListener("click", (e) => {
    if (e.target.classList.contains("event")) {
        if (confirm("Are you sure you want to delete this event?")) {
            const eventTitle = e.target.children[0].children[1].innerHTML;
            eventsArr.forEach((event) => {
                if (
                    event.day === activeDay &&
                    event.month === month + 1 &&
                    event.year === year
                ) {
                    event.events.forEach((item, index) => {
                        if (item.title === eventTitle) {
                            event.events.splice(index, 1);
                        }
                    });
                    //if no events left in a day then remove that day from eventsArr
                    if (event.events.length === 0) {
                        eventsArr.splice(eventsArr.indexOf(event), 1);
                        //remove event class from day
                        const activeDayEl = document.querySelector(".day.active");
                        if (activeDayEl.classList.contains("event")) {
                            activeDayEl.classList.remove("event");
                        }
                    }
                }
            });
            updateEvents(activeDay);
        }
    }
});
}

function saveEvents() {
    localStorage.setItem("events", JSON.stringify(eventsArr));
}

//function to get events from local storage
function getEvents() {
    //check if events are already saved in local storage then return event else nothing
    if (localStorage.getItem("events") === null) {
        return;
    }
    eventsArr.push(...JSON.parse(localStorage.getItem("events")));
}

function convertTime(time) {
    //convert time to 24 hour format
    let timeArr = time.split(":");
    let timeHour = timeArr[0];
    let timeMin = timeArr[1];
    let timeFormat = timeHour >= 12 ? "PM" : "AM";
    timeHour = timeHour % 12 || 12;
    time = timeHour + ":" + timeMin + " " + timeFormat;
    return time;
}



// remove button
function removeBtns(selector) {
    $('.product_hour_button').show();
    $('.dual_product_hour').hide();
    const id = $(selector).data('id');
    $(selector).hide();
    $('#replacement_button'+id).show();
    
}

function checkout_form() {
    $('.calender_wrapper').hide();
    $('.checkout_wrapper').show();
}
// checkout_page

// var header = document.getElementById("myDIV");
// var btns = header.getElementsByClassName("payment_processors");
// console.log(btns,"dsgftbhnyerg");
// for (var i = 0; i < btns.length; i++) {
//     btns[i].addEventListener("click", function () {
//         var current = document.getElementsByClassName("actives");
//         current[0].className = current[0].className.replace("actives", "");
//         this.className += " actives";
//     });
// }

